import platform
import urllib.request
import gzip
import os
import json
from vndbapi.core import UnsupportedOSException
from vndbapi.const import DBG
HOME = os.path.expanduser("~")
TAGPATHLNX = HOME + "/.cache/vndbapi"
TAGPATHWIN = HOME + "\\AppData\\Roaming\\vndbapi"

JSONDICT = None

def initReadTags():
    global JSONDICT
    if DBG: print("[DBG] InitReadTags")

    if platform.system() == "Linux":
        if os.path.exists(TAGPATHLNX + "/tags.json"):
            jsonfile = TAGPATHLNX + "/tags.json"
            jsondata = open(jsonfile, "rb")
            JSONDICT = json.loads(jsondata.read())
        else:
            initDlTags()

    elif platform.system() == "Windows":
        if os.path.exists(TAGPATHWIN + "\\tags.json"):
            jsonfile = TAGPATHWIN + "\\tags.json"
            jsondata = open(jsonfile, "rb")
            JSONDICT = json.loads(jsondata.read())
        else:
            initDlTags()

    else:
        raise UnsupportedOSException(f'The OS: "{platform.system}" is not supported by vndbapi.tags!')


def initDlTags():
    if DBG: print("[DBG] InitDlTags")

    if platform.system() == "Linux":
        if os.path.exists(TAGPATHLNX + "/tags.json.gz"):
            os.remove(TAGPATHLNX + "/tags.json.gz")
        if os.path.exists(TAGPATHLNX + "/tags.json"):
            os.remove(TAGPATHLNX + "/tags.json")
        if os.path.exists(TAGPATHLNX):
            os.rmdir(TAGPATHLNX)
        os.mkdir(TAGPATHLNX)
        urllib.request.urlretrieve("https://dl.vndb.org/dump/vndb-tags-latest.json.gz", TAGPATHLNX + "/tags.json.gz")
        filein = open(TAGPATHLNX + "/tags.json.gz", "rb")
        fileout = open(TAGPATHLNX + "/tags.json", "wb")
        fileout.write(gzip.decompress(filein.read()))
        filein.close()
        fileout.close()
        os.remove(TAGPATHLNX + "/tags.json.gz")

    elif platform.system() == "Windows":
        if os.path.exists(TAGPATHWIN + "\\tags.json.gz"):
            os.remove(TAGPATHWIN + "\\tags.json.gz")
        if os.path.exists(TAGPATHWIN + "\\tags.json"):
            os.remove(TAGPATHWIN + "\\tags.json")
        if os.path.exists(TAGPATHWIN):
            os.rmdir(TAGPATHWIN)
        os.mkdir(TAGPATHWIN)
        urllib.request.urlretrieve("https://dl.vndb.org/dump/vndb-tags-latest.json.gz", TAGPATHWIN + "\\tags.json.gz")
        filein = open(TAGPATHWIN + "\\tags.json.gz", "rb")
        fileout = open(TAGPATHWIN + "\\tags.json", "wb")
        fileout.write(gzip.decompress(filein.read()))
        filein.close()
        fileout.close()
        os.remove(TAGPATHWIN + "\\tags.json.gz")

    else:
        raise UnsupportedOSException(f'The OS: "{platform.system}" is not supported by vndbapi.tags!')

def getIdByName(name: str) -> int:
    while JSONDICT is None:
        initReadTags()
    for i in JSONDICT:
        if i["name"] == name:
            if i["searchable"] == True:
                return i["id"]

def getCategory(tagid: int) -> str:
    while JSONDICT is None:
        initReadTags()
    for i in JSONDICT:
        if i["id"] == tagid:
            return i["cat"]

def getDescription(tagid: int) -> str:
    while JSONDICT is None:
        initReadTags()
    for i in JSONDICT:
        if i["id"] == tagid:
            return i["description"]

def getName(tagid: int) -> str:
    while JSONDICT is None:
        initReadTags()
    for i in JSONDICT:
        if i["id"] == tagid:
            return i["name"]

initReadTags()